(*
Copyright (c) 1997,1998 The Regents of the University of California.
All rights reserved.

Permission to use, copy, modify, and distribute this software for any
purpose, without fee, and without written agreement is hereby granted,
provided that the above copyright notice and the following two
paragraphs appear in all copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*)

signature Lexeme =
    sig

	type identifier
	structure IdKey: ORD_KEY where type ord_key = identifier
	val idKey : identifier -> IdKey.ord_key
	val keyId : IdKey.ord_key -> identifier
	val idToString : identifier -> string
	val nullId : identifier
	val mkIdentifier : string -> identifier
	val mkFreshId : unit -> identifier
	val mkAggrId : identifier -> identifier

	val reset : unit -> unit

(*	structure IdSet : ORD_SET
	sharing type IdSet.item = identifier*)

	datatype constant =
	    Integer of int
	  | BigInteger of identifier
	  | String of identifier
	  | Character of identifier
	  | Real of identifier
	    
	datatype operator =
	    Plus
	  | Minus
	  | Mul
	  | Div
	  | Mod
	  | Incr
	  | Decr
	  | And
	  | Or
	  | Not
	  | BitAnd
	  | BitOr
	  | BitNot
	  | BitXor
	  | Rshift
	  | Lshift
	  | Lt
	  | Le
	  | Gt
	  | Ge
	  | Eq
	  | Ne
	  | Address
	  | LabelAddress
	  | Deref
	  | UnaryMinus
	  | Flow

    end
