
/*  ###############################################################
    ##
    ##     C Tree Builder
    ##
    ##     File:         cgraph.h
    ##
    ##     Programmer:   Shawn Flisakowski
    ##     Date:         Nov 27, 1998
    ##
    ##
    ###############################################################  */

#ifndef     CGRAPH_H
#define     CGRAPH_H
 
#ifndef     _HPUX_SOURCE
#define     _HPUX_SOURCE
#endif

#include <vector>    // STL

#include <iostream>

/*  ###############################################################  */

#define    ON    (1)
#define    OFF   (0)

class Symbol;
class cgNode;

typedef    std::vector<cgNode*>   cgNodeList;
 
/*  ###############################################################  */

class cgNode
{
  public:
    cgNode();
    cgNode( Symbol *nme = NULL );
    ~cgNode();

    void print(ostream& out) const;

    Symbol        *name;        // function name
    char          *filename;    // defined in this file.

    bool           defined;
    bool           used;
    bool           std;         // Is this defined in the C library?

    long           nUses;       // list of functions used in this one.
    cgNodeList     uses;

    cgNode        *next;        // for storage in cgNodeTbl.
};

/*  ###############################################################  */

const int kMaxNodeTblBckts = 256;

class cgNodeTbl
{
  public:
    cgNodeTbl();
    ~cgNodeTbl();

    cgNode    *insert( Symbol *sym );
    void       setStd();

    cgNode    *tbl[kMaxNodeTblBckts];
};

/*  ###############################################################  */

#endif     /* CGRAPH_H */
