
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
// o
// o     File:         heap.h
// o
// o     Programmer:   Shaun Flisakowski
// o     Date:         Apr 27, 1994
// o 
// o     Multi-heap Manager
// o
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#ifndef    HEAP_H
#define    HEAP_H

#include "utype.h"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#define    MIN_HUNK_ARRY        8
#define    DEFLT_RATIO        256

#define    min(X, Y)        ( ((X) < (Y)) ? (X) : (Y) )
#define    max(X, Y)        ( ((X) > (Y)) ? (X) : (Y) )

#define    PNTR_SZE         sizeof(void*)
#define    ALGN_SZE         sizeof(double)
#define    MIN_SIZE         max(PNTR_SZE,ALGN_SZE)

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
class HeapItem
{
  public:
    HeapItem() { nxtItem = NULL; }

    HeapItem        *nxtItem;    // For a linked list of memory chunks
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

class Heap 
{
  private:
    HeapItem  *storage;    // A linked list of all chunks allocated.

  public:
    Heap();
   ~Heap();

    // Delete all chunks in this heap.
    void clear();

    void  insert(HeapItem *chunk);
    bool  free(HeapItem *chunk);
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#endif    // HEAP_H 
