/**************************************************************************
/    lexer.h
/ *************************************************************************/

#ifndef LEXER_H
#define LEXER_H

#include <stdio.h>

#include "config.h"
#include "tree.h"

/**************************************************************************/

/* Maximum length for strings and identifiers */
#define MAX_STRING_LEN        512

/* If we allow a comment as a token, we need to let them be larger. */
#define MAX_TOKN_LEN        8192

/**************************************************************************/

typedef union {

    treeNode *node;
    leafNode *leaf;

    ifNode  *ifn;
    forNode *forn;

} tree_union;

/******************************************************/

/*    For Flex compatibility  */

#undef  YYSTYPE
#define YYSTYPE tree_union

/******************************************************/

int  get_lineno (char *txt, leafNode *leaf);
void yywarn  (char *s);
int  yyerror (char *s);
int  yyerr   (char *s);

/******************************************************/

#endif  /* LEXER_H */
