
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
// o
// o     File:         NameTbl.h
// o
// o     Programmer:   Shawn Flisakowski
// o     Date:         Sep 10, 1998
// o
// o     Name Storage
// o
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#ifndef     NAMETBL_H
#define     NAMETBL_H

#include "config.h"
#include "utype.h"

const int kMaxHashBckts = 511;

#ifndef NULL
#define NULL 0
#endif

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

class StrItem
{
  public:
    StrItem(char *str, int len=0);
    StrItem(char *str, int len, uint hsh);
   ~StrItem();

    bool     equal(StrItem *that) const;
    bool     equal(char *that) const;

    char*    string() const { return this ? _string : (char*) NULL; }
    uint     hash() const { return _hash; }
    StrItem* next() const { return _next; }

    void     setString(char  *str, int len=0);
    void     setNext(StrItem *nxt) { _next = nxt; }

    char       *_string;
    uint        _hash;

    StrItem    *_next;
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

class NameTbl
{
  public:
    NameTbl();
   ~NameTbl();

    StrItem*    insert( char *sym, int len );

  private:
    StrItem    *tbl[kMaxHashBckts];
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#endif    /* NAMETBL_H */
