/*  o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
    o+
    o+     File:         parseenv.h
    o+
    o+     Programmer:   Shawn Flisakowski
    o+     Date:         Apr 7, 1995
    o+
    o+     The parsing envirornment.
    o+
    o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o  */

#ifndef PARSEENV_H
#define PARSEENV_H

#include <stdio.h>

#include "config.h"
#include "heap.h"
#include "tree.h"
#include "symbol.h"

/* o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o */

#define    YYBUFF_SIZE    4096

    /*  Redefinition - original provided by flex/lex */
#ifndef    YY_BUFFER_STATE_DEFD
typedef  struct yy_buffer_state  *YY_BUFFER_STATE;
#endif

/* o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o */

class ParseEnv
{
  public:
    ParseEnv( FILE *fp, char *fname );
   ~ParseEnv();

    treeNode          *parse_tree;  /* Pointer to the parse tree */
    Heap              *node_heap;   /* Allocated tree nodes */

    StrItem           *realfile;    /* The file _really_ being parsed. */
    int                in_realfile;

    char              *filename;    /* The name of the file */
    FILE              *yyin;        /* A pointer to an open file */

    int                yylineno;    /* Line number */
    int                yycolno;     /* Column number */
    int                yynxtcol;    /* next Column number */

    YY_BUFFER_STATE    yybuff;      /* A buffer for the lexer */

    Context           *contxt;
    ParseEnv          *next;        /* Ptr to next ParseEnv */
};

/* o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o */

#endif    /* PARSEENV_H  */
