/*  o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
    o+
    o+     File:         project.cpp
    o+
    o+     Programmer:   Shaun Flisakowski
    o+     Date:         Nov 27, 1998
    o+
    o+     TransUnit and Project classes.
    o+
    o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o  */

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <fstream>

#include "project.h"

#include "express.h"
#include "stemnt.h"

#include "token.h"
#include "tree.h"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#ifdef    USE_GCC_4_CPP
#undef    LIB_CPP
#define   LIB_CPP    "gcc -E "
#endif

#ifdef    USE_CAT_4_CPP
#undef    LIB_CPP
#define   LIB_CPP    "cat "
#endif

#ifdef    USE_CPP_4_CPP
#ifndef   LIB_CPP
#define   LIB_CPP    "/lib/cpp "
#endif
#endif

#ifndef   LIB_CPP
#define   LIB_CPP    "/lib/cpp "
#endif	

/* o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o */

extern FILE *yyin;

extern int yyparse(void);
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size );
void            yy_switch_to_buffer( YY_BUFFER_STATE buff );
void            yy_delete_buffer( YY_BUFFER_STATE buff );

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

char what_version[] = "@(#) " VERSION;

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

Project *gProject = NULL;

// Fill in StdPath[1] with path obtained from running cpp on <stddef.h>
char  *StdPath[] = { "/usr/include/", NULL, NULL };

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
void
InitStdPath()
{
#define    INCL_EXAMPLE    "incl.h"
    {
        ofstream inclOut(INCL_EXAMPLE);
        inclOut << "#include <stddef.h>\n";
    }

    Project prj;

    TransUnit *unit = prj.parse(INCL_EXAMPLE);

    for (Statement *stemnt = unit->head; stemnt; stemnt = stemnt->next)
        if (stemnt->isInclude())
        {
            InclStemnt *incl = (InclStemnt*) stemnt;

            char *inclPath = new char [strlen(incl->filename)+1];
            char *inclEnd;

            strcpy(inclPath,incl->filename);
   
            if ((inclEnd = strrchr(inclPath, '/')))
            {
                inclEnd++;
                *inclEnd = '\0';
                StdPath[1] = inclPath;
                cerr << "Using: '" << inclPath
                     << "' as the standard include path.\n"; 
            }
            else
                delete [] inclPath;
    
            break;
        }

    remove(INCL_EXAMPLE);
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
TransUnit::TransUnit()
{
    filename = NULL;

    head = tail = NULL;

    next = NULL;

    contxt = NULL;
    parseTree = NULL;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
TransUnit::~TransUnit()
{
    Statement *ste, *nxt = NULL;

    for (ste=head; ste; ste=ste->next)
    {
        delete nxt;
        nxt = ste;
    }

    delete nxt;

    delete contxt;

    delete [] filename;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
void
TransUnit::findStemnt( fnStemntCallback cb )
{
    Statement *ste;

    for (ste=head; ste; ste=ste->next)
    {
        ste->findStemnt(cb);
    }
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
void
TransUnit::findFunctionDef( fnFunctionCallback cb )
{
    Statement *ste;

    for (ste=head; ste; ste=ste->next)
    {
        // Function definition can only occur at the top level.
        if (ste->isFuncDef())
            (cb)((FunctionDef*) ste);
    }
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
void
TransUnit::add( Statement *stemnt )
{
    if (stemnt)
    { 
        stemnt->next = NULL;
    
        if (tail)
            tail->next = stemnt;
        else
            head = stemnt;
    
        tail = stemnt;
    }
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
void
TransUnit::insert(Statement *stemnt, Statement *after /* =NULL */)
{
    if (stemnt)
    {
        stemnt->next = NULL;

        if (tail)
        {
            if (after)
            {
                stemnt->next = after->next;
                after->next = stemnt;
            }
            else
            {
                stemnt->next = head;
                head = stemnt;
            }

            if (stemnt->next == NULL)
                tail = stemnt;
        }
        else
            head = tail = stemnt;
    }
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
ostream&
operator<<(ostream& out, const TransUnit& tu)
{
    bool    inInclude = false;
    Statement *stemnt;

    for (stemnt=tu.head; stemnt; stemnt=stemnt->next)
    {
        if (inInclude)
        {
            if (stemnt->isEndInclude())
                inInclude = false;
        }
        else
        {
            if (stemnt->isInclude())
                inInclude = true;

            out << *stemnt << endl;
        }
    }

    return out;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
TransUnit*
buildTransUnit(treeNode *node)
{
    TransUnit *result = new TransUnit();
    Statement *stemnt;

    if (node)
    {
        switch (node->which)
        {
            default:
            case NONE_T:
                cout << "NONE_T\n";
                break;

            case LEAF_T:
                stemnt = buildStatement(node);
                result->add(stemnt);
                break;

            case IF_T:
                cout << "IF_T\n";
                break;

            case FOR_T:
                // A function definition.
                stemnt = buildStatement(node);
                result->add(stemnt);
                break;

            case NODE_T:
                switch (node->type)
                {
                    default:
                        break;

                    case TN_TRANS_LIST:
                        result = buildTransUnit(node->lnode);
                        stemnt = buildStatement(node->rnode);
                        result->add(stemnt);
                        break;

                    case TN_DECL:
                        // A top-level declaration.
                        stemnt = buildStatement(node);
                        result->add(stemnt);
                        break;
                }
                break;
        }
    }

    return result;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
Project::Project()
{
    head = NULL;
    tail = NULL;

    nameTbl = new NameTbl();
}

Project::~Project()
{
    TransUnit *trans, *nxt = NULL;

    for (trans=head; trans; trans=trans->next)
    {
        delete nxt;
        nxt = trans;
    }

    delete nxt;

    delete nameTbl;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
// Parse a file and add it to the list of stored TransUnits
TransUnit*
Project::parse( char *path, bool use_cpp /* =true */ )
{
    FILE       *fp;
    char       cpp_cmmd[500];
    char       cpp_file[200];
    treeNode   *parse_tree = (treeNode*) NULL;
    char       *end;
    Context    *contxt;

    gProject = this;

    strcpy(cpp_file, path);
    end = strrchr(cpp_file,'.');

    if (!end)
    {
      cerr << "No '.' found in filename '" << path << "'\n";
      return NULL;
    }

    if (use_cpp) 
        sprintf(end, "_pp");
 
/*
  willey
    need to redirect output to file if using GCC, not give target file
    as final argument, as in cpp
*/

    if (use_cpp)
    {
#ifdef  USE_GCC_4_CPP
        sprintf(cpp_cmmd,"%s -DCTREE -D__STDC__ %s > %s",LIB_CPP, path, cpp_file);

#elif defined(USE_CAT_4_CPP)

        sprintf(cpp_cmmd,"%s %s > %s", LIB_CPP, path, cpp_file);
#else
        sprintf(cpp_cmmd, "%s -DCTREE -D__STDC__ %s %s", LIB_CPP, path, cpp_file);
#endif

        /*
          willey
          debugging line to see what preprocessor is being called
        */
#ifdef  DEBUG
        //cerr << cpp_cmmd << endl;
#endif

        system(cpp_cmmd);
    }
 
    if ((fp = fopen(cpp_file,"r")) == NULL)
        return NULL;
    
    contxt = new Context();

    Parse_TOS = new ParseEnv(fp,path);
    Parse_TOS->contxt = contxt; 

    yy_switch_to_buffer(Parse_TOS->yybuff);
    yyin = Parse_TOS->yyin;

    contxt->EnterScope();

    while(yyparse())
        ;

    parse_tree = Parse_TOS->parse_tree;

    if (use_cpp && remove(cpp_file))
    {
      cerr << "Remove of file '" << cpp_file << "' failed.\n";
    }

    if (parse_tree == NULL)
    {
        delete contxt;
        return NULL;
    }

    /* Build the translation unit. */
    TransUnit *unit = buildTransUnit(parse_tree);
    
    unit->contxt = contxt;    
    unit->parseTree = parse_tree;
    unit->filename = new char [strlen(path)+1];
    strcpy(unit->filename,path);

    contxt->ExitScope();

    if (tail == NULL)
    {
        head = tail = unit;
    }
    else
    {
        tail->next = unit;
        tail = unit;
    }

    return unit;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
