/*  o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
    o+
    o+     File:         project.h
    o+
    o+     Programmer:   Shaun Flisakowski
    o+     Date:         Nov 27, 1998
    o+
    o+     TransUnit and Project classes.
    o+
    o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o  */

#ifndef    PROJECT_H
#define    PROJECT_H

#include <stdlib.h>
#include <iostream.h>
#include <assert.h>

#include "tree.h"
#include "parseenv.h"
#include "symbol.h"
#include "callback.h"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#define    VERSION    "C-Tree Version 1.05"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

extern void   InitStdPath();
extern char  *StdPath[];

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

class Statement;

class TransUnit
{
  public:
    /* List of Statements */
    TransUnit();
    ~TransUnit();

    void findStemnt( fnStemntCallback cb );
    void findFunctionDef( fnFunctionCallback cb );

    void add( Statement *stemnt );
    void insert(Statement *stemnt, Statement *after=NULL);

    char         *filename;   // The file we parsed this from.

    Statement    *head;       // The first statement in the list.
    Statement    *tail;       // The last statement in the list.

    TransUnit    *next;       // For building a list.

    // Hold onto this context.
    Context      *contxt;

    treeNode     *parseTree;  // The old-style parse tree.

  friend ostream& operator<< (ostream& out, const TransUnit& tu);
};

TransUnit   *buildTransUnit(treeNode *node);

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

class Project
{
  public:
    // List of TransUnit
    Project();
    ~Project();

    // Parse a file and add it to the list of stored TransUnits
    TransUnit *parse( char *path, bool use_cpp = true );

    TransUnit    *head;       // The first unit in the list.
    TransUnit    *tail;       // The last unit in the list.

  
    // The stack and top of the stack
    ParseEnv     *Parse_TOS;

    // The global name table.
    NameTbl      *nameTbl;
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

extern Project *gProject;

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#endif  /* PROJECT_H */

