signature Gen_TOKENS =
sig
type ('a,'b) token
type svalue
val EOF:  'a * 'a -> (svalue,'a) token
val ALIGNOF:  'a * 'a -> (svalue,'a) token
val LABEL:  'a * 'a -> (svalue,'a) token
val TYPEOF:  'a * 'a -> (svalue,'a) token
val SIZEOF:  'a * 'a -> (svalue,'a) token
val END:  'a * 'a -> (svalue,'a) token
val BEGIN:  'a * 'a -> (svalue,'a) token
val ELLIPSIS:  'a * 'a -> (svalue,'a) token
val SEMICOLON:  'a * 'a -> (svalue,'a) token
val RETURN:  'a * 'a -> (svalue,'a) token
val GOTO:  'a * 'a -> (svalue,'a) token
val DEFAULT:  'a * 'a -> (svalue,'a) token
val CASE:  'a * 'a -> (svalue,'a) token
val SWITCH:  'a * 'a -> (svalue,'a) token
val CONTINUE:  'a * 'a -> (svalue,'a) token
val BREAK:  'a * 'a -> (svalue,'a) token
val FOR:  'a * 'a -> (svalue,'a) token
val WHILE:  'a * 'a -> (svalue,'a) token
val DO:  'a * 'a -> (svalue,'a) token
val ELSE:  'a * 'a -> (svalue,'a) token
val IF:  'a * 'a -> (svalue,'a) token
val TYPEDEF:  'a * 'a -> (svalue,'a) token
val UNION:  'a * 'a -> (svalue,'a) token
val ENUM:  'a * 'a -> (svalue,'a) token
val STRUCT:  'a * 'a -> (svalue,'a) token
val DOUBLE:  'a * 'a -> (svalue,'a) token
val FLOAT:  'a * 'a -> (svalue,'a) token
val INT:  'a * 'a -> (svalue,'a) token
val CHAR:  'a * 'a -> (svalue,'a) token
val VOID:  'a * 'a -> (svalue,'a) token
val LONG:  'a * 'a -> (svalue,'a) token
val SHORT:  'a * 'a -> (svalue,'a) token
val UNSIGNED:  'a * 'a -> (svalue,'a) token
val SIGNED:  'a * 'a -> (svalue,'a) token
val NONCONST:  'a * 'a -> (svalue,'a) token
val VOLATILE:  'a * 'a -> (svalue,'a) token
val QUALIFIER: (Lexeme.identifier) *  'a * 'a -> (svalue,'a) token
val CONST:  'a * 'a -> (svalue,'a) token
val EXTERN:  'a * 'a -> (svalue,'a) token
val STATIC:  'a * 'a -> (svalue,'a) token
val REGISTER:  'a * 'a -> (svalue,'a) token
val AUTO:  'a * 'a -> (svalue,'a) token
val INLINE:  'a * 'a -> (svalue,'a) token
val POUND: (string) *  'a * 'a -> (svalue,'a) token
val STRINGCONSTANT: (string) *  'a * 'a -> (svalue,'a) token
val CONSTANT: (Lexeme.constant) *  'a * 'a -> (svalue,'a) token
val FUNCTION:  'a * 'a -> (svalue,'a) token
val EXTENSION:  'a * 'a -> (svalue,'a) token
val ATTRIBUTE:  'a * 'a -> (svalue,'a) token
val HIGHEST:  'a * 'a -> (svalue,'a) token
val TYPE_DEC_SPEC:  'a * 'a -> (svalue,'a) token
val TYPEDEF_NAME: (Lexeme.identifier) *  'a * 'a -> (svalue,'a) token
val IDENTIFIER: (Lexeme.identifier) *  'a * 'a -> (svalue,'a) token
val RC:  'a * 'a -> (svalue,'a) token
val LC:  'a * 'a -> (svalue,'a) token
val RB:  'a * 'a -> (svalue,'a) token
val LB:  'a * 'a -> (svalue,'a) token
val RP:  'a * 'a -> (svalue,'a) token
val LP:  'a * 'a -> (svalue,'a) token
val COLON:  'a * 'a -> (svalue,'a) token
val QUESTION:  'a * 'a -> (svalue,'a) token
val COMMA:  'a * 'a -> (svalue,'a) token
val PTR:  'a * 'a -> (svalue,'a) token
val DOT:  'a * 'a -> (svalue,'a) token
val ASSIGN: (Lexeme.operator option) *  'a * 'a -> (svalue,'a) token
val NE:  'a * 'a -> (svalue,'a) token
val EQ:  'a * 'a -> (svalue,'a) token
val GE:  'a * 'a -> (svalue,'a) token
val GT:  'a * 'a -> (svalue,'a) token
val LE:  'a * 'a -> (svalue,'a) token
val LT:  'a * 'a -> (svalue,'a) token
val LSHIFT:  'a * 'a -> (svalue,'a) token
val RSHIFT:  'a * 'a -> (svalue,'a) token
val BIT_XOR:  'a * 'a -> (svalue,'a) token
val BIT_NOT:  'a * 'a -> (svalue,'a) token
val BIT_OR:  'a * 'a -> (svalue,'a) token
val BIT_AND:  'a * 'a -> (svalue,'a) token
val NOT:  'a * 'a -> (svalue,'a) token
val OR:  'a * 'a -> (svalue,'a) token
val AND:  'a * 'a -> (svalue,'a) token
val DECR:  'a * 'a -> (svalue,'a) token
val INCR:  'a * 'a -> (svalue,'a) token
val MOD:  'a * 'a -> (svalue,'a) token
val DIV:  'a * 'a -> (svalue,'a) token
val MUL:  'a * 'a -> (svalue,'a) token
val MINUS:  'a * 'a -> (svalue,'a) token
val PLUS:  'a * 'a -> (svalue,'a) token
end
signature Gen_LRVALS=
sig
structure Tokens : Gen_TOKENS
structure ParserData:PARSER_DATA
sharing type ParserData.Token.token = Tokens.token
sharing type ParserData.svalue = Tokens.svalue
end
