structure Info: INFO =
struct

    (*************************************************************)
    (* Linux                                                     *)
    (*************************************************************)

    fun getInfo' stat =
	let val line = TextIO.inputLine stat
	in
	    TextIO.closeIn stat;
	    line
	end
	    handle ex => (TextIO.closeIn stat;
			  raise ex)

    fun getInfo (pid) =
	let val stat = TextIO.openIn ("/proc/" ^ pid ^ "/stat")
	    val statContents = getInfo' stat
	    fun isDelimiter c = (c = #" ")
	    val data = String.tokens isDelimiter statContents
	    fun getInt n =
		valOf (Int.fromString (List.nth (data, n)))
	in
	    {size = getInt 22,
	     rss =  4 * 1024 * (3 + getInt 23)}
	end

end (* structure Info *)