(* CParser for this application *)

(* Symbol table also uniquely numbers scopes *)
structure ExtraInfo =
    struct

	type scopeInfo = int
	type symInfo = unit
	type astInfo = unit

        val nameAnonAggregates = true

	val curLabel = ref 1

	fun enterScope () =
	    let val lab = !curLabel
	    in
		curLabel := !curLabel + 1;
		lab
	    end

	fun rootScopeInfo () = 0

	fun reset () = (curLabel := 1)
    end

structure CParser = GenFront(ExtraInfo)
structure AST = CParser.AST
structure Unparse = UnparseFn(structure AST = AST)

