
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
// o
// o     File:         heap.cpp
// o
// o     Programmer:   Shaun Flisakowski
// o     Date:         Apr 27, 1994
// o
// o     Multi-Heap Manager
// o
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#include <iostream.h>
#include <string.h>
#include <stdlib.h>

#include "heap.h"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
Heap::Heap()
{
    storage = NULL;
}

Heap::~Heap()
{
    clear();
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
void
Heap::clear()
{
    HeapItem *here, *prev = NULL;

    for (here=storage; here; here = here->nxtItem)
    {
        delete prev;
        prev = here;
    }

    delete prev;

    storage = NULL;
}

void
Heap::insert(HeapItem *chunk)
{
    chunk->nxtItem = storage;
    storage = chunk;
}

bool
Heap::free(HeapItem *chunk)
{
    HeapItem *here, *prev = NULL;

    for (here=storage; here; here = here->nxtItem)
    {
        if (here == chunk)
            break;
    }

    if (here == chunk)
    {
        if (prev != NULL)
            prev->nxtItem = here->nxtItem;
        else
            storage = here->nxtItem;

        delete here;
    }
    else
        return false;

    return true;
}

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
