
%{
/*************************************************
 *    trigraph.l
 *************************************************/

#undef YY_INPUT

#    ifdef STRING_PARSE

#define    min(X,Y)    ((X)<(Y) ? (X) : (Y))

    /* Scan input from a string instead */
#define YY_INPUT(buf,result,max_size) \
  do { \
     int n = min(max_size, parseEnv->parselimit - parseEnv->parseptr);\
     if (n>0){ \
        memcpy(buf,parseEnv->parseptr,(unsigned int) n); \
        parseEnv->parseptr += n; \
        result = n; \
     } else \
        result = YY_NULL; \
  } while(0)

#    else    /* not STRING_PARSE */

    /* Scan input from a file pointer (default) */
#define YY_INPUT(buf,result,max_size) \
    do { \
        if (fgets(buf,max_size,yyin) == NULL) { \
           result = YY_NULL; \
        } else { \
           result = strlen(buf); \
        } \
    } while(0)

#    endif    /* not STRING_PARSE */

#if 0
EXTERN int yylex ARGS((YYSTYPE *lvalp));

/*  To give some args to yylex */
#undef YY_DECL
#define YY_DECL int yylex YY_PROTO((YYSTYPE *lvalp))
#endif

%}
%x Start STR
%a 9000
%o 9000

tg              "??"

%%

<INITIAL,STR>{tg}"("        { fputs("[",stdout); }
<INITIAL,STR>{tg}")"        { fputs("]",stdout); }
<INITIAL,STR>{tg}"<"        { fputs("{",stdout); }
<INITIAL,STR>{tg}">"        { fputs("}",stdout); }
<INITIAL,STR>{tg}"/"        { fputs("\\",stdout); }
<INITIAL,STR>{tg}"!"        { fputs("|",stdout); }
<INITIAL,STR>{tg}"'"        { fputs("^",stdout); }
<INITIAL,STR>{tg}"-"        { fputs("~",stdout); }
<INITIAL,STR>{tg}"="        { fputs("#",stdout); }

<INITIAL>\"    { fputs("\"",stdout); BEGIN(STR); }
<STR>\"        { fputs("\"",stdout); BEGIN(INITIAL); }
<STR>\\\"      { fputs("\\\"",stdout); }
<STR>\\\\      { fputs("\\",stdout); }

<INITIAL>"<:"           { fputs("[",stdout); }
<INITIAL>":>"           { fputs("]",stdout); }
<INITIAL>"<%"           { fputs("{",stdout); }
<INITIAL>"%>"           { fputs("}",stdout); }
<INITIAL>"%:"           { fputs("#",stdout); }

%%

/***********************************************************************/
