#include "SourceFileTree.h"
#include <iostream>		// TEST CODE
using namespace std;	// TEST CODE
#include "MainFrame.h"
#define NEW_FOLDER_NAME	"New Folder "
#define NEW_FOLDER_MAX	500
#define NEW_FOLDER_DEPTH 10
CSourceFileTree::CSourceFileTree():
TreeView()
{
	m_ptsTreeModel = TreeStore::create( m_tmcColumns );
	set_model( m_ptsTreeModel );
	set_reorderable();

	TreeModel::Row tmRow = *( m_ptsTreeModel->append() );
	tmRow[ m_tmcColumns.m_colItemType ] = ITEM_TYPE_PROJECT;
	tmRow[ m_tmcColumns.m_colName	  ] = "New Project";

	append_column_editable( "", m_tmcColumns.m_colName );
	( (CellRendererText*)get_column_cell_renderer( 0 ) )->property_editable() = false;
	
	set_rubber_banding();
	set_enable_tree_lines();
	set_headers_visible( false );
	m_ptsTreeSelection = get_selection();
	m_ptsTreeSelection->set_mode( SELECTION_MULTIPLE );

	show_all_children();
}
CSourceFileTree::~CSourceFileTree()
{

}
bool CSourceFileTree::on_button_release_event( GdkEventButton* pebEventButton )
{
	if ( pebEventButton->button == 3 )
	{
		vector<TreeModel::Path> vecPath = m_ptsTreeSelection->get_selected_rows();
		vector<TreeModel::Path>::const_iterator itPath;
		vector<TreeModel::Path>::const_iterator itPathEnd = vecPath.end();
		TreeModel::Row tmRow;
		unsigned int auiItemType[ ITEM_TYPE_COUNT ]  = { 0 };
		for ( itPath = vecPath.begin() ; itPath != itPathEnd ; ++itPath )
		{
			tmRow		=	*( m_ptsTreeModel->get_iter( *itPath ) );
			++auiItemType[ tmRow[ m_tmcColumns.m_colItemType ] ];
		}
		Menu::MenuList& mlMenuList = m_mwPopupMenu.items();
		mlMenuList.clear();
		if ( auiItemType[ ITEM_TYPE_PROJECT ] )
		{
			if ( auiItemType[ ITEM_TYPE_FOLDER ] == 0 && auiItemType[ ITEM_TYPE_FILE ] == 0 )
			{
				mlMenuList.push_back( Menu_Helpers::MenuElem( "Add Folder", sigc::mem_fun( *this, &CSourceFileTree::OnMenuAddFolder ) ) );
				mlMenuList.push_back( Menu_Helpers::MenuElem( "Add File", sigc::mem_fun( *this, &CSourceFileTree::OnMenuAddFile ) ) );
				mlMenuList.push_back( Menu_Helpers::MenuElem( "Rename", sigc::mem_fun( *this, &CSourceFileTree::OnMenuRename ) ) );
			}
		}
		else
		{
			if ( auiItemType[ ITEM_TYPE_FOLDER ] > 0 && auiItemType[ ITEM_TYPE_FILE ] == 0 )
			{
				if ( auiItemType[ ITEM_TYPE_FOLDER ] == 1 )
				{
					mlMenuList.push_back( Menu_Helpers::MenuElem( "Add Folder", sigc::mem_fun( *this, &CSourceFileTree::OnMenuAddFolder ) ) );
					mlMenuList.push_back( Menu_Helpers::MenuElem( "Add File", sigc::mem_fun( *this, &CSourceFileTree::OnMenuAddFile ) ) );
					mlMenuList.push_back( Menu_Helpers::MenuElem( "Rename", sigc::mem_fun( *this, &CSourceFileTree::OnMenuRename ) ) );
				}
				mlMenuList.push_back( Menu_Helpers::MenuElem( "Remove", sigc::mem_fun( *this, &CSourceFileTree::OnMenuRemove ) ) );
			}
			else if ( auiItemType[ ITEM_TYPE_FOLDER ] == 0 && auiItemType[ ITEM_TYPE_FILE ] > 0 )
			{
				mlMenuList.push_back( Menu_Helpers::MenuElem( "Open", sigc::mem_fun( *this, &CSourceFileTree::OnMenuOpen ) ) );
				mlMenuList.push_back( Menu_Helpers::MenuElem( "Remove", sigc::mem_fun( *this, &CSourceFileTree::OnMenuRemove ) ) );
			}
			else if ( auiItemType[ ITEM_TYPE_FOLDER ] > 0 && auiItemType[ ITEM_TYPE_FILE ] > 0 )
			{
				mlMenuList.push_back( Menu_Helpers::MenuElem( "Remove", sigc::mem_fun( *this, &CSourceFileTree::OnMenuRemove ) ) );
			}
		}
		if ( mlMenuList.empty() == false )
		{
			m_mwPopupMenu.popup( pebEventButton->button, pebEventButton->time );
		}
	}
	return TreeView::on_button_release_event( pebEventButton );
}
void CSourceFileTree::on_row_activated( const TreeModel::Path& tmPath, TreeViewColumn* ptvColumn )
{
	TreeModel::Row tmRow = *( m_ptsTreeModel->get_iter( tmPath ) );
	if ( tmRow[ m_tmcColumns.m_colItemType ] == ITEM_TYPE_FILE )
	{
		g_pmfMainFrame->GetSourceTextView().AddSourceTextPage( tmRow[ m_tmcColumns.m_colFile ], tmRow[ m_tmcColumns.m_colName ] );
	}
	TreeView::on_row_activated( tmPath, ptvColumn );
}
void CSourceFileTree::OnMenuAddFolder()
{
	vector< int > vecNewFolderNumber;
	TreeModel::Path tmPath							=	*( m_ptsTreeSelection->get_selected_rows().begin() );
	TreeNodeChildren tncNode						=	m_ptsTreeModel->get_iter( tmPath )->children();
	TreeNodeChildren::iterator	itNode				=	tncNode.begin();
	TreeNodeChildren::iterator	itNodeEnd			=	tncNode.end();
	size_t						sizeNewFolderName	=	strlen( NEW_FOLDER_NAME );
	string						strNumber;
	stringstream				strsPureNumber;
	int							nFolderNumber;
	for ( ; itNode != itNodeEnd ; ++itNode )
	{
		if ( itNode->get_value( m_tmcColumns.m_colItemType ) == ITEM_TYPE_FOLDER )
		{
			const ustring&	strName = itNode->get_value( m_tmcColumns.m_colName );
			if ( strName.size() > sizeNewFolderName )
			{
				strNumber = strName.substr( sizeNewFolderName );
				strsPureNumber.str( "" );
				strsPureNumber.clear();
				strsPureNumber << atoi( strNumber.c_str() );
				if ( strNumber == strsPureNumber.str() )
				{
					strsPureNumber >> nFolderNumber;
					if ( nFolderNumber >= 1 && nFolderNumber <= NEW_FOLDER_MAX )
					{
						vecNewFolderNumber.push_back( nFolderNumber );
					}
				}
			}
		}
	}
	sort( vecNewFolderNumber.begin(), vecNewFolderNumber.end() );
	int nNewFolderNumber;
	vector< int >::iterator itNumber = vecNewFolderNumber.begin();
	if ( vecNewFolderNumber.empty() == false && *itNumber == 1)
	{
		vector< int >::iterator itNumberEnd = --vecNewFolderNumber.end();
		for ( ; itNumber != itNumberEnd ; ++itNumber )
		{
			if ( *( itNumber + 1 ) - *itNumber > 1 )
			{
				break;
			}
		}
		nNewFolderNumber = *itNumber + 1;
	}
	else
	{
		nNewFolderNumber = 1;
	}
	if ( nNewFolderNumber > NEW_FOLDER_MAX )
	{
		MessageDialog msgDialog( "Can't create a new folder.\nPlease rename or remove the existing folders." );
		msgDialog.set_title( "Error" );
		msgDialog.set_transient_for( *g_pmfMainFrame );
		msgDialog.run();
		return;
	}
	stringstream strsNewFolderName;
	strsNewFolderName << NEW_FOLDER_NAME << nNewFolderNumber;
	TreeModel::Row tmRow		=	*( m_ptsTreeModel->append( tncNode ) ); //////////
	tmRow[ m_tmcColumns.m_colItemType ] = ITEM_TYPE_FOLDER;
	tmRow[ m_tmcColumns.m_colName	  ] = strsNewFolderName.str();
	expand_to_path( tmPath );
	set_cursor( TreePath( tmRow ) );
	OnMenuRename();
}
bool CSourceFileTree::FindFolderNew( const TreeModel::iterator& itTreeModel )
{
	/*
	if ( itTreeModel->get_value( m_tmcColumns.m_colItemType ) == ITEM_TYPE_FOLDER )
	{
		const ustring& strName = itTreeModel->get_value( m_tmcColumns.m_colName );
		size_t sizeNewFolderName = strlen( NEW_FOLDER_NAME );
		if ( strName.size() > sizeNewFolderName )
		{
			string strNumber = strName.substr( sizeNewFolderName );
			stringstream strsPureNumber;
			strsPureNumber << atoi( strNumber.c_str() );
			if ( strNumber == strsPureNumber.str() )
			{
				int nFolderNumber;
				strsPureNumber >> nFolderNumber;
				if ( nFolderNumber >= 1 && nFolderNumber <= NEW_FOLDER_MAX )
				{
					vecNewFolderNumber.push_back( nFolderNumber );
				}
			}
		}
	}
	*/
	return false;
}
void CSourceFileTree::OnMenuAddFile()
{
	FileChooserDialog fcdDialog( "Please choose files" );
	fcdDialog.set_select_multiple();
	fcdDialog.set_transient_for( *g_pmfMainFrame );
	fcdDialog.add_button( Stock::OPEN, RESPONSE_OK );
	fcdDialog.add_button( Stock::CANCEL, RESPONSE_CANCEL );
	FileFilter ffFilter;
	ffFilter.set_name( "Text files" );
	ffFilter.add_mime_type( "text/plain" );
	fcdDialog.add_filter( ffFilter );
	if ( fcdDialog.run() == RESPONSE_OK )
	{
		SListHandle< ustring > listFile				=	fcdDialog.get_filenames();
		SListHandle< ustring >::iterator itFile		=	listFile.begin();
		SListHandle< ustring >::iterator itFileEnd	=	listFile.end();
		RefPtr< File > pfileFile;
		TreeModel::Path tmPath		=	*( m_ptsTreeSelection->get_selected_rows().begin() );
		TreeNodeChildren tncNode	=	m_ptsTreeModel->get_iter( tmPath )->children();
		TreeModel::Row tmRow;
		bool bFind;
		for ( ; itFile != itFileEnd ; ++itFile )
		{
			pfileFile							=	File::create_for_path( *itFile );
			m_ptsTreeModel->foreach_iter( sigc::bind( sigc::mem_fun( *this, &CSourceFileTree::FindFile ), pfileFile, &bFind ) );
			if ( bFind == true )
			{
				continue;
			}
			tmRow								=	*( m_ptsTreeModel->append( tncNode ) );
			tmRow[ m_tmcColumns.m_colItemType ] =	ITEM_TYPE_FILE;
			tmRow[ m_tmcColumns.m_colName	  ] =	pfileFile->get_basename();
			tmRow[ m_tmcColumns.m_colFile	  ] =	pfileFile;
		}
		expand_to_path( tmPath );
	}
}
bool CSourceFileTree::FindFile( const TreeModel::iterator& itTreeModel, RefPtr< File > pfileFile, bool* bFind )
{
	if ( itTreeModel->get_value( m_tmcColumns.m_colItemType ) == ITEM_TYPE_FILE )
	{
		*bFind = pfileFile->equal( itTreeModel->get_value( m_tmcColumns.m_colFile ) );
	}
	else
	{
		*bFind = false;
	}
	return *bFind;
}
void CSourceFileTree::OnMenuRemove()
{
	vector<TreeModel::Path> vecPath = m_ptsTreeSelection->get_selected_rows();
	vector<TreeModel::Path>::const_reverse_iterator itPath;
	vector<TreeModel::Path>::const_reverse_iterator itPathEnd = vecPath.rend();
	TreeModel::Row tmRow;
	for ( itPath = vecPath.rbegin() ; itPath != itPathEnd ; ++itPath )
	{
		m_ptsTreeModel->erase( m_ptsTreeModel->get_iter( *itPath ) );
	}
}
void CSourceFileTree::OnMenuOpen()
{
	vector<TreeModel::Path> vecPath = m_ptsTreeSelection->get_selected_rows();
	vector<TreeModel::Path>::const_iterator itPath;
	vector<TreeModel::Path>::const_iterator itPathEnd = vecPath.end();
	TreeModel::Row tmRow;
	for ( itPath = vecPath.begin() ; itPath != itPathEnd ; ++itPath )
	{
		tmRow		=	*( m_ptsTreeModel->get_iter( *itPath ) );
		if ( tmRow[ m_tmcColumns.m_colItemType ] == ITEM_TYPE_FILE )
		{
			g_pmfMainFrame->GetSourceTextView().AddSourceTextPage( tmRow[ m_tmcColumns.m_colFile ], tmRow[ m_tmcColumns.m_colName ] );
		}
	}
}
void CSourceFileTree::OnMenuRename()
{
	//  ߺ   CellRendererText
	//  ݵ Է, 鸸  ȵ, Է ڿ յ   Trim
	// Drag and Drop p122, Sorting
	//  ׿  ,  
	( (CellRendererText*)get_column_cell_renderer( 0 ) )->property_editable() = true;
	set_cursor( *( m_ptsTreeSelection->get_selected_rows().begin() ), *get_column( 0 ), true );
	( (CellRendererText*)get_column_cell_renderer( 0 ) )->property_editable() = false;
}