#ifndef SWA_SOURCE_FILE_TREE_H
#define SWA_SOURCE_FILE_TREE_H
#include <gtkmm.h>
using namespace Gtk;
using namespace Glib;
using namespace Gio;
#include <vector>
#include <algorithm>
using namespace std;
enum ESFTItemType
{
	ITEM_TYPE_PROJECT = 0,
	ITEM_TYPE_FOLDER,
	ITEM_TYPE_FILE,
	ITEM_TYPE_COUNT,
};
class CTreeModelColumns : public TreeModel::ColumnRecord
{
public:
	CTreeModelColumns()
	{
		add(m_colItemType);
		add(m_colName);
		add(m_colFile);
	}
	TreeModelColumn< ESFTItemType >		m_colItemType;
	TreeModelColumn< ustring >			m_colName;
	TreeModelColumn< RefPtr< File > >	m_colFile;
};
class CSourceFileTree : public TreeView
{
protected:
	CTreeModelColumns m_tmcColumns;
	RefPtr<TreeStore> m_ptsTreeModel;
	RefPtr<TreeSelection> m_ptsTreeSelection;
	Menu m_mwPopupMenu;
	vector< int > m_vecNewFolderNumber;
	CellRendererText m_crtRenderer;
	TreeView::Column m_tvcColumn;
public:
	CSourceFileTree();
	virtual ~CSourceFileTree();
protected:
	virtual bool on_button_release_event( GdkEventButton* pebEventButton );
	virtual void on_row_activated( const TreeModel::Path& tmPath, TreeViewColumn* ptvColumn );
	virtual void OnMenuAddFolder();
	virtual bool FindFolderNew( const TreeModel::iterator& itTreeModel );
	virtual void OnMenuAddFile();
	virtual bool FindFile( const TreeModel::iterator& itTreeModel, RefPtr< File > pfileFile, bool* bFind );
	virtual void OnMenuRemove();
	virtual void OnMenuOpen();
	virtual void OnMenuRename();
};
#endif