#ifndef SWA_SOURCE_TEXT_PAGE_H
#define SWA_SOURCE_TEXT_PAGE_H
#include<gtkmm.h>
using namespace Gtk;
using namespace Glib;
using namespace Gdk;
using namespace Gio;
#include<iostream>											// TEST CODE
using namespace std;										// TEST CODE
#include<windows.h>											// TEST CODE
class CSourceTextPage : public ScrolledWindow
{
protected:
	TextView						m_tvwSourceTextView;
	RefPtr< TextBuffer >			m_pTextBuffer;
	vector< string >				m_vecKeyword;
	size_t							m_sizeKeywordMin;
	size_t							m_sizeKeywordMax;
	vector< string >				m_vecKeywordPrep;
	size_t							m_sizeKeywordPrepMin;
	size_t							m_sizeKeywordPrepMax;
	vector< string >				m_vecKeywordIfElif;
	size_t							m_sizeKeywordIfElifMin;
	size_t							m_sizeKeywordIfElifMax;
	vector< string >				m_vecKeywordPragma;
	size_t							m_sizeKeywordPragmaMin;
	size_t							m_sizeKeywordPragmaMax;
	RefPtr< File >					m_pFile;
	LARGE_INTEGER					m_liSystemFrequency;	// TEST CODE
public:
											CSourceTextPage();
	virtual									~CSourceTextPage();
	virtual					bool			SetFile( RefPtr< File > pFile );
	virtual					RefPtr< File >	GetFile();
	virtual					void			Refresh();
protected:
	virtual					void	OnChangedTextBuffer();
	virtual	inline			void	_InitializeKeyword();																			// Ű ʱȭ
	virtual	inline			void	_InitializeKeywordPrep();																		// ó Ű ʱȭ
	virtual	inline			void	_InitializeKeywordIfElif();																		// #if #elif ڽ Ű ʱȭ
	virtual	inline			void	_InitializeKeywordPragma();																		// #pragma ڽ Ű ʱȭ
	virtual inline			void	_GetMinMaxSize( const vector< string >& vecString, size_t& sizeMin, size_t& sizeMax ) const;	// ش ڿ ߿ ּ, ִ  
	virtual	inline			void	_InitializeTag();																				// ± ʱȭ
	virtual __forceinline	bool	_IsSeparator( gunichar chLetter ) const;														// ش ڰ  
	virtual __forceinline	bool	_IsNumber( gunichar chLetter ) const;															// ش ڰ   (0-9)
	virtual __forceinline	bool	_IsAlphabet( gunichar chLetter ) const;															// ش ڰ ĺ  (A-Z, a-z)
	virtual __forceinline	bool	_IsKeyword( const string& strKeyword ) const;													// ش ڿ Ϲ Ű 
	virtual __forceinline	bool	_IsKeywordPrep( const string& strKeyword ) const;												// ش ڿ ó Ű 
	virtual __forceinline	bool	_IsKeywordIfElif( const string& strKeyword ) const;												// ش ڿ #if #elif  ڽ Ű 
	virtual __forceinline	bool	_IsKeywordPragma( const string& strKeyword ) const;												// ش ڿ #pragma  ڽ Ű 
	virtual	__forceinline	void	_ChangeTextColor();																				// ؽƮ    
};
#endif