#include "SourceTextView.h"
#include <iostream>		// TEST CODE
using namespace std;	// TEST CODE
#include "SourceTextPage.h"
#include "MainFrame.h"
CSourceTextView::CSourceTextView():
Notebook()
{
	Menu::MenuList& mlMenuList = m_mwPopupMenu.items();
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Refresh", sigc::mem_fun( *this, &CSourceTextView::OnRefreshMenu ) ) );
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Refresh All", sigc::mem_fun( *this, &CSourceTextView::OnRefreshAllMenu ) ) );
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Close", sigc::mem_fun( *this, &CSourceTextView::OnCloseMenu ) ) );
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Close All But This", sigc::mem_fun( *this, &CSourceTextView::OnCloseAllButThisMenu ) ) );
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Close All", sigc::mem_fun( *this, &CSourceTextView::OnCloseAllMenu ) ) );
	//  ?
	set_scrollable( true );
}
CSourceTextView::~CSourceTextView()
{

}
void CSourceTextView::AddSourceTextPage( RefPtr< File > pFile, const ustring& strName )
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CSourceTextPage* pstpSourceTextPage;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "SourceTextPage" )
		{
			pstpSourceTextPage = ( CSourceTextPage* )( *itWidget );
			if ( pstpSourceTextPage->GetFile()->equal( pFile ) == true )
			{
				pstpSourceTextPage->show();
				set_current_page( page_num( *pstpSourceTextPage ) );
				return;
			}
		}
	}
	pstpSourceTextPage = manage( new CSourceTextPage() );
	if ( pstpSourceTextPage->SetFile( pFile ) == false )
	{
		delete pstpSourceTextPage;
		return;
	}
	pstpSourceTextPage->set_name( "SourceTextPage" );
	append_page( *pstpSourceTextPage, *manage( new Label( strName ) ) );
	pstpSourceTextPage->show();
	set_current_page( page_num( *pstpSourceTextPage ) );
	set_tab_reorderable( *pstpSourceTextPage );
}
void CSourceTextView::on_switch_page( GtkNotebookPage* pnpNotebookPage, guint uiPageNumber )
{
	Notebook::on_switch_page( pnpNotebookPage, uiPageNumber );
}
bool CSourceTextView::on_button_press_event( GdkEventButton* pebEventButton )
{
	pebEventButton->button = 1;
	return Notebook::on_button_press_event( pebEventButton );
}
bool CSourceTextView::on_button_release_event( GdkEventButton* pebEventButton )
{
	if( pebEventButton->button == 3 )
	{
		m_mwPopupMenu.popup( pebEventButton->button, pebEventButton->time );
	}
	pebEventButton->button = 1;
	return Notebook::on_button_release_event( pebEventButton );
}
void CSourceTextView::OnRefreshMenu()
{
	Widget* wCurrentPage = get_nth_page( get_current_page() );
	CSourceTextPage* pstpSourceTextPage;
	if ( wCurrentPage->get_name() == "SourceTextPage" )
	{
		pstpSourceTextPage = ( CSourceTextPage* )wCurrentPage;
		pstpSourceTextPage->Refresh();
	}
}
void CSourceTextView::OnRefreshAllMenu()
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CSourceTextPage* pstpSourceTextPage;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "SourceTextPage" )
		{
			pstpSourceTextPage = ( CSourceTextPage* )( *itWidget );
			pstpSourceTextPage->Refresh();
		}
	}
}
void CSourceTextView::OnCloseMenu()
{
	get_nth_page( get_current_page() )->hide();
	queue_draw();
}
void CSourceTextView::OnCloseAllButThisMenu()
{
	Widget* wCurrentPage = get_nth_page( get_current_page() );
	OnCloseAllMenu();
	wCurrentPage->show();
}
void CSourceTextView::OnCloseAllMenu()
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		( *itWidget )->hide();
	}
	queue_draw();
}