// PSATDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PSAT.h"
#include "PSATDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define LOGIN_TIMER 1

/////////////////////////////////////////////////////////////////////////////
// CPSATDlg dialog

CPSATDlg::CPSATDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPSATDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPSATDlg)
	m_strRegAddContent = _T("");
	m_strRegCompany = _T("");
	m_strRegPath = _T("");
	m_strRegProgram = _T("");
	m_strRegVersion = _T("");
	m_strAddContent = _T("");
	m_strCompany = _T("");
	m_strFilePath = _T("");
	m_strProgram = _T("");
	m_strVersion = _T("");
	m_strDependence = _T("");
	m_stdAddInformation = _T("");
	m_strSearString = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32

	mk_OrgMain.left  = 0;
	mk_OrgMain.right = 0;
	m_nFilePathType = FILE_PATH_TYPE_NULL;

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_bLoginCheck				= TRUE; 
	m_tabControlItem1.mask		= TCIF_TEXT;
	m_tabControlItem1.pszText	= "  Ȯ  ";
	m_tabControlItem2.mask		= TCIF_TEXT;
	m_tabControlItem2.pszText	= "  ˻  ";
	m_tabControlItem3.mask		= TCIF_TEXT;
	m_tabControlItem3.pszText	= "    ";
}

void CPSATDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPSATDlg)
	DDX_Control(pDX, IDC_COMBO_SEARCH_INDEX, m_cbSearchIndex);
	DDX_Text(pDX, IDC_EDIT_SEAR_STRING, m_strSearString);
	DDX_Control(pDX, IDC_LIST_SEAR_LIST, m_listSearList);
	DDX_Control(pDX, IDC_BUTTON_SEAR_SEARCH, m_btnSearSearch);
	DDX_Control(pDX, IDC_EDIT_SEAR_STRING, m_edtSearString);
	DDX_Control(pDX, IDC_BUTTON_REWRITE, m_btnRewrite);
	DDX_Control(pDX, IDC_BUTTON_REG, m_btnReg);
	DDX_Control(pDX, IDC_STATIC_REG_VERSION, m_staticRegVersion);
	DDX_Control(pDX, IDC_STATIC_REG_PROGRAM, m_staticRegProgram);
	DDX_Control(pDX, IDC_STATIC_REG_PATH, m_staticRegPath);
	DDX_Control(pDX, IDC_STATIC_REG_COMPANY, m_staticRegCompany);
	DDX_Control(pDX, IDC_STATIC_REG_ADD_CONTENT, m_staticRegAddContent);
	DDX_Control(pDX, IDC_EDIT_REG_VERSION, m_edtRegVersion);
	DDX_Control(pDX, IDC_EDIT_REG_PROGRAM, m_edtRegProgram);
	DDX_Control(pDX, IDC_EDIT_REG_PATH, m_edtRegPath);
	DDX_Control(pDX, IDC_EDIT_REG_COMPANY, m_edtRegCompany);
	DDX_Control(pDX, IDC_EDIT_REG_ADD_CONTENT, m_edtRegAddContent);
	DDX_Text(pDX, IDC_EDIT_REG_ADD_CONTENT, m_strRegAddContent);
	DDX_Text(pDX, IDC_EDIT_REG_COMPANY, m_strRegCompany);
	DDX_Text(pDX, IDC_EDIT_REG_PATH, m_strRegPath);
	DDX_Text(pDX, IDC_EDIT_REG_PROGRAM, m_strRegProgram);
	DDX_Text(pDX, IDC_EDIT_REG_VERSION, m_strRegVersion);
	DDX_Control(pDX, IDC_BUTTON_REG_FILE, m_btnRegFile);
	DDX_Control(pDX, IDC_BUTTON_REG_DIRECTORY, m_btnRegDirectory);
	DDX_Control(pDX, IDC_COMBO_REG_VERSION, m_cbRegVersion);
	DDX_Control(pDX, IDC_COMBO_REG_PROGRAM, m_cbRegProgram);
	DDX_Control(pDX, IDC_COMBO_REG_COMPANY, m_cbRegCompany);
	DDX_Control(pDX, IDC_BUTTON_CHECK, m_btnCheck);
	DDX_Control(pDX, IDC_EDIT_ADD_INFORMATION, m_edtAddInformation);
	DDX_Control(pDX, IDC_EDIT_DEPENDENCE, m_edtDependence);
	DDX_Control(pDX, IDC_EDIT_VERSION, m_edtVersion);
	DDX_Control(pDX, IDC_EDIT_PROGRAM_NAME, m_edtProgram);
	DDX_Control(pDX, IDC_EDIT_FILE_PATH, m_edtFilePath);
	DDX_Control(pDX, IDC_EDIT_COMPANY_NAME, m_edtCompany);
	DDX_Control(pDX, IDC_EDIT_ADD_CONTENT, m_edtAddContent);
	DDX_Control(pDX, IDC_BUTTON_VIEW_REPLY, m_btnViewReply);
	DDX_Control(pDX, IDC_BUTTON_FILE, m_btnFile);
	DDX_Control(pDX, IDC_BUTTON_DIRECTORY, m_btnDirectory);
	DDX_Control(pDX, IDC_BUTTON_LOGIN, m_btnLogin);
	DDX_Control(pDX, IDC_STATIC_PROMGRA_INFO, m_staticProgram);
	DDX_Control(pDX, IDC_STATIC_DEPENDENCE, m_staticDependence);
	DDX_Control(pDX, IDC_STATIC_ADD_INFO, m_staticAddInfo);
	DDX_Control(pDX, IDC_STATIC_VERSION, m_staticVersion);
	DDX_Control(pDX, IDC_STATIC_PROGRAM, m_staticProgmra);
	DDX_Control(pDX, IDC_STATIC_COMPANY, m_staticCompany);
	DDX_Control(pDX, IDC_STATIC_ADD_CONTENT, m_staticAddContent);
	DDX_Control(pDX, IDC_STATIC_PATH, m_staticPath);
	DDX_Control(pDX, IDC_STATIC_EDITOR, m_CtrlStaticEditor);
	DDX_Text(pDX, IDC_EDIT_ADD_CONTENT, m_strAddContent);
	DDX_Text(pDX, IDC_EDIT_COMPANY_NAME, m_strCompany);
	DDX_Text(pDX, IDC_EDIT_FILE_PATH, m_strFilePath);
	DDX_Text(pDX, IDC_EDIT_PROGRAM_NAME, m_strProgram);
	DDX_Text(pDX, IDC_EDIT_VERSION, m_strVersion);
	DDX_Text(pDX, IDC_EDIT_DEPENDENCE, m_strDependence);
	DDX_Text(pDX, IDC_EDIT_ADD_INFORMATION, m_stdAddInformation);
	DDX_Control(pDX, IDC_TAB1, m_tabControl);
	DDX_Control(pDX, IDC_PROGRESS1, m_progressDependence);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPSATDlg, CDialog)
	//{{AFX_MSG_MAP(CPSATDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_DIRECTORY, OnButtonDirectory)
	ON_BN_CLICKED(IDC_BUTTON_FILE, OnButtonFile)
	ON_BN_CLICKED(IDC_BUTTON_LOGIN, OnButtonLogin)
	ON_WM_TIMER()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab1)
	ON_BN_CLICKED(IDC_BUTTON_REWRITE, OnButtonRewrite)
	ON_BN_CLICKED(IDC_BUTTON_REG, OnButtonReg)
	ON_BN_CLICKED(IDC_BUTTON_REG_DIRECTORY, OnButtonRegDirectory)
	ON_BN_CLICKED(IDC_BUTTON_REG_FILE, OnButtonRegFile)
	ON_CBN_SELCHANGE(IDC_COMBO_REG_COMPANY, OnSelchangeComboRegCompany)
	ON_BN_CLICKED(IDC_BUTTON_CHECK, OnButtonCheck)
	ON_BN_CLICKED(IDC_BUTTON_SEAR_SEARCH, OnButtonSearSearch)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_RECEIVE_DATA, OnReceive)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPSATDlg message handlers

BOOL CPSATDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_myHtmlView = new CMyHtmlView();
	if (!m_myHtmlView->ViewCreate(&m_CtrlStaticEditor, this, FALSE, TRUE))
	{
		MessageBox(_T("Error creating CHtmlEditor"), _T("Error"), MB_ICONSTOP);
		CDialog::EndDialog(0);
		return TRUE;
	}

	m_myHtmlView->Logout();
	m_listSearList.SetColumnItem();
	m_tabControl.InsertItem( 1, &m_tabControlItem1 );
	m_tabControl.InsertItem( 2, &m_tabControlItem2 );
	m_tabControl.InsertItem( 3, &m_tabControlItem3 );

//	m_btnReg.EnableWindow( !m_bLoginCheck );
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPSATDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPSATDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPSATDlg::OnCancel() 
{
	m_myHtmlView->Logout();
	delete m_myHtmlView;
	CDialog::OnCancel();
}

void CPSATDlg::OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	/* tab1 */ 
	m_edtVersion.ShowWindow(SW_HIDE);
	m_edtProgram.ShowWindow(SW_HIDE);
	m_edtFilePath.ShowWindow(SW_HIDE);
	m_edtCompany.ShowWindow(SW_HIDE);
	m_edtAddContent.ShowWindow(SW_HIDE);
	m_progressDependence.ShowWindow(SW_HIDE);
	m_btnViewReply.ShowWindow(SW_HIDE);
	m_btnFile.ShowWindow(SW_HIDE);
	m_btnDirectory.ShowWindow(SW_HIDE);
	m_edtAddInformation.ShowWindow(SW_HIDE);
	m_edtDependence.ShowWindow(SW_HIDE);
	m_staticPath.ShowWindow(SW_HIDE);
	m_staticProgram.ShowWindow(SW_HIDE);
	m_staticDependence.ShowWindow(SW_HIDE);
	m_staticAddInfo.ShowWindow(SW_HIDE);
	m_staticVersion.ShowWindow(SW_HIDE);
	m_staticProgmra.ShowWindow(SW_HIDE);
	m_staticCompany.ShowWindow(SW_HIDE);
	m_staticAddContent.ShowWindow(SW_HIDE);
	m_btnCheck.ShowWindow(SW_HIDE);
	
	/* tab 2 */
	m_listSearList.ShowWindow(SW_HIDE);
	m_btnSearSearch.ShowWindow(SW_HIDE);
	m_edtSearString.ShowWindow(SW_HIDE);
	m_cbSearchIndex.ShowWindow(SW_HIDE);

	/* tab 3 */
	m_btnReg.ShowWindow(SW_HIDE);
	m_btnRewrite.ShowWindow(SW_HIDE);
	m_staticRegVersion.ShowWindow(SW_HIDE);
	m_staticRegProgram.ShowWindow(SW_HIDE);
	m_staticRegPath.ShowWindow(SW_HIDE);
	m_staticRegCompany.ShowWindow(SW_HIDE);
	m_staticRegAddContent.ShowWindow(SW_HIDE);
	m_edtRegVersion.ShowWindow(SW_HIDE);
	m_edtRegProgram.ShowWindow(SW_HIDE);
	m_edtRegPath.ShowWindow(SW_HIDE);
	m_edtRegCompany.ShowWindow(SW_HIDE);
	m_edtRegAddContent.ShowWindow(SW_HIDE);
	m_cbRegVersion.ShowWindow(SW_HIDE);
	m_cbRegProgram.ShowWindow(SW_HIDE);
	m_cbRegCompany.ShowWindow(SW_HIDE);
	m_btnRegFile.ShowWindow(SW_HIDE);
	m_btnRegDirectory.ShowWindow(SW_HIDE);


	switch ( m_tabControl.GetCurSel() ) 
	{
	case 0 :
		CheckDefaultSet();
		break;
	case 1 : 
		SearDefaultSet();
		break;
	case 2 : 
		RegDefaultSet();
		break;
	}
	
//	*pResult = 0;
}

LONG CPSATDlg::OnReceive(UINT wParam, LONG lParam)
{
	switch ( wParam )
	{
	case MESSAGE_SEARCHED_KEY : 
		{
			int nIndex; 
			CString strMessage = m_myHtmlView->m_strParsingMessage;
		
			nIndex = strMessage.Find( DIVISION_MESSAGE_MIDDLE );
			m_strCompany = strMessage.Left( nIndex );
			strMessage = strMessage.Right( strMessage.GetLength() - nIndex - 2 );

			nIndex = strMessage.Find( DIVISION_MESSAGE_MIDDLE );
			m_strProgram = strMessage.Left( nIndex );
			strMessage = strMessage.Right( strMessage.GetLength() - nIndex - 2 );

			nIndex = strMessage.Find( DIVISION_MESSAGE_MIDDLE );
			m_strVersion = strMessage.Left( nIndex );
			strMessage = strMessage.Right( strMessage.GetLength() - nIndex - 2 );

			nIndex = strMessage.Find( DIVISION_MESSAGE_MIDDLE );
			// Ű = strMessage.Left( nIndex );
			m_strAddContent = strMessage.Right( strMessage.GetLength() - nIndex - 2 );

			m_myHtmlView->m_nIndexWebPage = WEB_PAGE_NULL;
			m_myHtmlView->m_strParsingMessage = "";

//			m_progressDependence.SetPos(73);
//			m_edtDependence.SetWindowText("ŷڼ 60~80% ڷ ŷ  ִ ڷ Դϴ.");
//			m_edtAddInformation.SetWindowText("        [10]                   õ[3]                   Ű[1]");

			UpdateData(FALSE);
		}
		break;
	case MESSAGE_CHANGE_ADDTAB : 
		{
			m_tabControl.SetCurSel( 2 );
			OnSelchangeTab1( NULL, NULL );
		}
		break;
	case MESSAGE_SEARCHED_DATA :
		{
			int nIndex; 
			CString strMessage = m_myHtmlView->m_strParsingMessage;
		
			nIndex = strMessage.Find( DIVISION_MESSAGE_MIDDLE );
			m_strCompany = strMessage.Left( nIndex );
			strMessage = strMessage.Right( strMessage.GetLength() - nIndex - 2 );

			nIndex = strMessage.Find( DIVISION_MESSAGE_MIDDLE );
			m_strProgram = strMessage.Left( nIndex );
			strMessage = strMessage.Right( strMessage.GetLength() - nIndex - 2 );

			nIndex = strMessage.Find( DIVISION_MESSAGE_MIDDLE );
			m_strVersion = strMessage.Left( nIndex );
			strMessage = strMessage.Right( strMessage.GetLength() - nIndex - 2 );

			nIndex = strMessage.Find( DIVISION_MESSAGE_MIDDLE );
			// Ű = strMessage.Left( nIndex );
			m_strAddContent = strMessage.Right( strMessage.GetLength() - nIndex - 2 );

			m_myHtmlView->m_nIndexWebPage = WEB_PAGE_NULL;
			m_myHtmlView->m_strParsingMessage = "";
		}
		break;
	case MESSAGE_SEARCHED_DATAS :
		{
			POSITION pos; 
			LV_ITEM	lvitem; 
			int i = 0;
			int iActItem, nLine;
			CString str;
				
			CProgramInfo* pProgram;

			pos = m_myHtmlView->m_listProgramInfo.GetHeadPosition();

			while ( pos )
			{
				pProgram = ( CProgramInfo* )m_myHtmlView->m_listProgramInfo.GetAt( pos );
				m_myHtmlView->m_listProgramInfo.GetNext( pos );

				nLine = m_listSearList.GetItemCount();

				lvitem.mask		= LVIF_TEXT | LVIF_IMAGE;
				lvitem.iItem	= nLine;
				lvitem.iSubItem = 0;
				lvitem.pszText	= (LPSTR)(LPCTSTR)pProgram->m_strProgram;	
				iActItem		= m_listSearList.InsertItem( &lvitem );
					
				lvitem.iItem	= iActItem;
				lvitem.iSubItem = 1;
				lvitem.pszText	= (LPSTR)(LPCTSTR)pProgram->m_strCompany;	
				m_listSearList.SetItem( &lvitem );	

				lvitem.iItem	= iActItem;
				lvitem.iSubItem = 2;
				lvitem.pszText	= (LPSTR)(LPCTSTR)pProgram->m_strVersion;	
				m_listSearList.SetItem( &lvitem );	

				//m_listSearList.InsertColumn( nIndex,  );
			}
		}
		break;
	}
	return 0;
}

void CPSATDlg::OnTimer(UINT nIDEvent) 
{
	switch ( nIDEvent ) 
	{
	case LOGIN_TIMER: 
		LoginCheck();
		break;
	default :
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

void CPSATDlg::OnButtonLogin() 
{
	if ( m_bLoginCheck )
	{
		CLoginDlg dlg; 
		if ( dlg.DoModal() == IDOK )
		{
			m_myHtmlView->Login( dlg.m_strId, dlg.m_strPass );
			SetTimer( LOGIN_TIMER, 1000, NULL );
		}
	}
	else
	{
		m_myHtmlView->Logout();	
		m_bLoginCheck = TRUE;
		m_btnLogin.SetWindowText("α");
//		m_btnReg.EnableWindow( !m_bLoginCheck );
	}
}

void CPSATDlg::LoginCheck()
{
	KillTimer( LOGIN_TIMER );
	if ( m_myHtmlView->m_nRepetitonCount ) 
	{
		MessageBox( "ID Password ùٸ ʽϴ.", "α " );
		OnButtonLogin();
	}
	else
	{
		m_bLoginCheck = FALSE;
		m_btnLogin.SetWindowText("α׾ƿ");
//		m_btnReg.EnableWindow( !m_bLoginCheck );
	}
}

/***********/
/*   */ 
/***********/

void CPSATDlg::RegDefaultSet() 
{
	m_btnReg.ShowWindow(SW_SHOW);
	m_btnRewrite.ShowWindow(SW_SHOW);
	m_staticRegVersion.ShowWindow(SW_SHOW);
	m_staticRegProgram.ShowWindow(SW_SHOW);
	m_staticRegPath.ShowWindow(SW_SHOW);
	m_staticRegCompany.ShowWindow(SW_SHOW);
	m_staticRegAddContent.ShowWindow(SW_SHOW);
	m_edtRegVersion.ShowWindow(SW_SHOW);
	m_edtRegProgram.ShowWindow(SW_SHOW);
	m_edtRegPath.ShowWindow(SW_SHOW);
	m_edtRegCompany.ShowWindow(SW_SHOW);
	m_edtRegAddContent.ShowWindow(SW_SHOW);
	m_cbRegVersion.ShowWindow(SW_SHOW);
	m_cbRegProgram.ShowWindow(SW_SHOW);
	m_cbRegCompany.ShowWindow(SW_SHOW);
	m_btnRegFile.ShowWindow(SW_SHOW);
	m_btnRegDirectory.ShowWindow(SW_SHOW);
	m_edtRegCompany.EnableWindow(TRUE);
	m_edtRegProgram.EnableWindow(TRUE);

	m_edtRegVersion.SetWindowText("");
	m_edtRegProgram.SetWindowText("");
	m_edtRegPath.SetWindowText("");
	m_edtRegCompany.SetWindowText("");
	m_edtRegAddContent.SetWindowText("");

	UpdateData(TRUE);

	m_nFilePathType = FILE_PATH_TYPE_NULL; 

	m_cbRegCompany.ResetContent();
	m_cbRegProgram.ResetContent();
	m_cbRegVersion.ResetContent();

	m_cbRegCompany.AddString( "Blizard" );
	m_cbRegCompany.AddString( "MicroSoft" );
	m_cbRegCompany.AddString( "̽ƮƮ" );
	m_cbRegCompany.AddString( "ѱ۰ǻ" );
	m_cbRegCompany.InsertString( 0, "Է" );

	m_cbRegCompany.SendMessage(CB_SETCURSEL, 0, 0);

	m_cbRegProgram.InsertString( 0, "Է" );
	m_cbRegProgram.SendMessage(CB_SETCURSEL, 0, 0);

	m_cbRegVersion.InsertString( 0, "Է" );
	m_cbRegVersion.SendMessage(CB_SETCURSEL, 0, 0);

	m_edtRegCompany.SetFocus();
}

void CPSATDlg::OnButtonRewrite() 
{
	RegDefaultSet();
}

void CPSATDlg::OnButtonReg() 
{
	UpdateData(TRUE);

	CString strTitle	= _T("");
	CString strBody		= _T("");
	
	strTitle += TITLE_MESSAGE_START;

	if ( m_strRegCompany == "" ) 
	{
		MessageBox("ȸ Էּ."," ");
		m_edtRegCompany.SetFocus();
		return; 
	}
	strTitle += m_strRegCompany;
	strTitle += DIVISION_MESSAGE_MIDDLE;

	if ( m_strRegProgram == "" ) 
	{
		MessageBox("α׷ Էּ."," ");
		m_edtRegProgram.SetFocus();
		return; 
	}
	strTitle += m_strRegProgram;
	strTitle += DIVISION_MESSAGE_MIDDLE;

	if ( m_strRegVersion == "" ) 
	{
		MessageBox(" Էּ."," ");
		m_edtRegVersion.SetFocus();
		return; 
	}
	strTitle += m_strRegVersion;
	strTitle += DIVISION_MESSAGE_MIDDLE;

	if ( m_strRegPath == "" )
	{
		MessageBox("θ ּ."," ");
		return; 
	}

	CString strKey = ImportKeyValue ( m_strRegPath, m_nFilePathType );

	strTitle += strKey;
	strTitle += TITLE_MESSAGE_END;

	strBody += BODY_MESSAGE_START;
	strBody += m_strRegAddContent;
	strBody += BODY_MESSAGE_END;

	m_myHtmlView->WriteBoard( strTitle, strBody );	

	MessageBox("ϵǾϴ."," ");
	RegDefaultSet();
}

void CPSATDlg::OnButtonRegDirectory() 
{
    ITEMIDLIST *pidlBrowse; 
    char pszPathname[1000]; 
    BROWSEINFO BrInfo;
    BrInfo.hwndOwner = GetSafeHwnd(); 
    BrInfo.pidlRoot = NULL;
    
    memset(&BrInfo, 0, sizeof(BrInfo));
    BrInfo.pszDisplayName = pszPathname;
    BrInfo.lpszTitle = " ";
    BrInfo.ulFlags = BIF_RETURNONLYFSDIRS;

    pidlBrowse = ::SHBrowseForFolder(&BrInfo);

    if( pidlBrowse != NULL)
    {
        ::SHGetPathFromIDList(pidlBrowse, pszPathname);
		m_nFilePathType = FILE_PATH_TYPE_DIRECTORY;
        m_strRegPath = pszPathname;  
		m_edtRegPath.SetWindowText( m_strRegPath ); 
    }
}

void CPSATDlg::OnButtonRegFile() 
{
	CFileDialog dlg(TRUE);
	
	if ( dlg.DoModal() == IDOK)
	{
		m_nFilePathType = FILE_PATH_TYPE_FILE;
		m_strRegPath = dlg.GetPathName();
		m_edtRegPath.SetWindowText( m_strRegPath ); 
	}
}

void CPSATDlg::OnSelchangeComboRegCompany() 
{
	int nIndex	= m_cbRegCompany.GetCurSel(); 
	if ( !nIndex ) // Է
	{
		m_edtRegCompany.EnableWindow(TRUE);
		m_edtRegCompany.SetWindowText(""); 
		m_edtRegCompany.SetFocus();
	}
	else 
	{
		m_cbRegCompany.GetLBText( m_cbRegCompany.GetCurSel(), m_strRegCompany );
		m_edtRegCompany.EnableWindow(FALSE);
		UpdateData(FALSE);
	}
}


/***********/
/* Ȯ  */ 
/***********/

void CPSATDlg::OnButtonDirectory() 
{
    ITEMIDLIST *pidlBrowse; 
    char pszPathname[1000]; 
    BROWSEINFO BrInfo;
    BrInfo.hwndOwner = GetSafeHwnd(); 
    BrInfo.pidlRoot = NULL;
    
    memset(&BrInfo, 0, sizeof(BrInfo));
    BrInfo.pszDisplayName = pszPathname;
    BrInfo.lpszTitle = " ";
    BrInfo.ulFlags = BIF_RETURNONLYFSDIRS;

    pidlBrowse = ::SHBrowseForFolder(&BrInfo);

    if( pidlBrowse != NULL)
    {
        ::SHGetPathFromIDList(pidlBrowse, pszPathname);
		m_nFilePathType = FILE_PATH_TYPE_DIRECTORY;
        m_strFilePath = pszPathname;  //  
		UpdateData(FALSE);
    }
}

void CPSATDlg::OnButtonFile() 
{
	CFileDialog dlg(TRUE);
	
	if ( dlg.DoModal() == IDOK)
	{
		m_nFilePathType = FILE_PATH_TYPE_FILE;
		m_strFilePath = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CPSATDlg::OnButtonCheck() 
{
	if ( m_strFilePath == "" ) 
	{
		MessageBox("θ Ȯּ", "Ȯ");
		return;
	}

	CString strKey = ImportKeyValue ( m_strFilePath, m_nFilePathType );

	m_myHtmlView->SearchKey( strKey );
}

void CPSATDlg::CheckDefaultSet() 
{
	m_btnCheck.ShowWindow(SW_SHOW);
	m_edtVersion.ShowWindow(SW_SHOW);
	m_edtProgram.ShowWindow(SW_SHOW);
	m_edtFilePath.ShowWindow(SW_SHOW);
	m_edtCompany.ShowWindow(SW_SHOW);
	m_edtAddContent.ShowWindow(SW_SHOW);
	m_progressDependence.ShowWindow(SW_SHOW);
	m_btnViewReply.ShowWindow(SW_SHOW);
	m_btnFile.ShowWindow(SW_SHOW);
	m_btnDirectory.ShowWindow(SW_SHOW);
	m_edtAddInformation.ShowWindow(SW_SHOW);
	m_edtDependence.ShowWindow(SW_SHOW);
	m_staticPath.ShowWindow(SW_SHOW);
	m_staticProgram.ShowWindow(SW_SHOW);
	m_staticDependence.ShowWindow(SW_SHOW);
	m_staticAddInfo.ShowWindow(SW_SHOW);
	m_staticVersion.ShowWindow(SW_SHOW);
	m_staticProgmra.ShowWindow(SW_SHOW);
	m_staticCompany.ShowWindow(SW_SHOW);
	m_staticAddContent.ShowWindow(SW_SHOW);
	
	m_strAddContent = _T("");
	m_strCompany = _T("");
	m_strFilePath = _T("");
	m_strProgram = _T("");
	m_strVersion = _T("");
	m_strDependence = _T("");
	m_stdAddInformation = _T("");

	m_edtAddInformation.SetWindowText("");
	m_edtDependence.SetWindowText("");
	m_edtVersion.SetWindowText("");
	m_edtProgram.SetWindowText("");
	m_edtFilePath.SetWindowText("");
	m_edtCompany.SetWindowText("");
	m_edtAddContent.SetWindowText("");

	UpdateData(FALSE);
}


/***********/
/* ˻  */ 
/***********/

void CPSATDlg::SearDefaultSet()
{
	m_listSearList.ShowWindow(SW_SHOW);
	m_btnSearSearch.ShowWindow(SW_SHOW);
	m_edtSearString.ShowWindow(SW_SHOW);
	m_cbSearchIndex.ShowWindow(SW_SHOW);

	m_edtSearString.SetWindowText("");
	m_strSearString = "";

	m_edtSearString.SetFocus();

	UpdateData(FALSE);
}

void CPSATDlg::OnButtonSearSearch() 
{
	UpdateData(TRUE);

	if ( m_strSearString == "" ) 
	{
		MessageBox("˻ Ȯּ", "˻");
	}

	m_myHtmlView->Search( m_strSearString );
}

CString CPSATDlg::ImportKeyValue( CString strPath, int nFlag )
{
	CString strKey = _T("");
	CString strBuffer = _T("");
	CCheckSoftware cChecker;
	unsigned char szKeyBuffer[32];
	memset( szKeyBuffer, 0, sizeof ( szKeyBuffer ) );

	if ( nFlag == FILE_PATH_TYPE_FILE )
	{
		cChecker.GetHashValueFromFile( LPSTR(LPCTSTR(strPath)), szKeyBuffer );
	}
	else if ( nFlag == FILE_PATH_TYPE_DIRECTORY ) 
	{
		cChecker.GetHashValueFromDirectory( LPSTR(LPCTSTR(strPath)), szKeyBuffer );
	}

	for ( int i = 0; i < 32; i++ )
	{
		strBuffer.Format("%02X", szKeyBuffer[i]);
		strKey += strBuffer; 
	}

	return strKey; 
}

