#ifndef SWA_MAIN_FRAME_H
#define SWA_MAIN_FRAME_H
#include <gtkmm.h>
using namespace Gtk;
using namespace Glib;
using namespace Gio;
#include "TabView.h"
#include "ViewManager.h"
#include "ResultManager.h"
#include "ModuleManager/AnalysisModuleManager.h"
class CMainFrame : public Gtk::Window
{
protected:
	VBox				m_vbwVBox;		// m_vpwVPaned, m_hbbwHButtonBox
	VPaned				m_vpwVPaned;	// m_hpwHPaned, Ʈ 
	HPaned				m_hpwHPaned;	//  , ҽ ؽƮ 
	CTabView			m_tvTabView;
	CViewManager		m_stvViewManager;
	CResultManager		m_rvResultManager;
	RefPtr<UIManager>	m_pUIManager;
	RefPtr<ActionGroup>	m_pActionGroup;
	ustring				m_strProjectName;
	bool				m_bModified;
	RefPtr< File >		m_pFileProject;

	CAnalysisModuleManager	m_AnalysisModuleManager;
public:
	CMainFrame();
	virtual ~CMainFrame();
	virtual void OnAddModuleGraphView();
	virtual void OnAddModule();
	virtual bool on_delete_event( GdkEventAny* geaEvent );
	virtual bool NewProject( bool bReset = true );
	virtual void OnFileNewProject();
	virtual void OnFileSaveProject();
	virtual void OnFileSaveAsProject();
	virtual void OnFileOpenProject();
	virtual void OnFileQuit();
	virtual void OnHelpAbout();
	virtual void SetProjectName( const ustring& strProjectName );
	virtual ustring GetProjectName() const;
	virtual void Reset();
	virtual bool IsOpened( RefPtr< File > pFile );
	virtual bool IsSelected( RefPtr< File > pFile );
	virtual void SelectPage( RefPtr< File > pFile );
	virtual void SetModified( bool bModified = true );
	virtual bool GetModified();
	virtual CViewManager* GetViewManager();
	CTabView* GetTabView();

	CAnalysisModuleManager* GetAnalysisModuleManager();
	CModuleInfo* FindNodeInfoInAMM( unsigned uiModuleID );
};
extern CMainFrame* g_pmfMainFrame;
#endif

