#ifndef SWA_SOURCE_TEXT_VIEW_H
#define SWA_SOURCE_TEXT_VIEW_H
#include<gtkmm.h>
using namespace Gtk;
using namespace Glib;
using namespace Gdk;
using namespace Gio;
#include<iostream>											// TEST CODE
using namespace std;										// TEST CODE
#include<windows.h>											// TEST CODE
class CSourceTextView : public ScrolledWindow
{
protected:
	TextView				m_tvwViewManager;
	RefPtr< TextBuffer >	m_pTextBuffer;
	vector< string >		m_vecKeyword;
	size_t					m_sizeKeywordMin;
	size_t					m_sizeKeywordMax;
	vector< string >		m_vecKeywordPrep;
	size_t					m_sizeKeywordPrepMin;
	size_t					m_sizeKeywordPrepMax;
	vector< string >		m_vecKeywordIfElif;
	size_t					m_sizeKeywordIfElifMin;
	size_t					m_sizeKeywordIfElifMax;
	vector< string >		m_vecKeywordPragma;
	size_t					m_sizeKeywordPragmaMin;
	size_t					m_sizeKeywordPragmaMax;
	RefPtr< File >			m_pFile;
	LARGE_INTEGER			m_liSystemFrequency;	// TEST CODE
public:
									CSourceTextView();
	virtual							~CSourceTextView();
	virtual			bool			SetFile( RefPtr< File > pFile, bool bDialog = true );
	virtual			RefPtr< File >	GetFile();
	virtual			void			Refresh();
protected:
	virtual			void	OnChangedTextBuffer();
	inline			void	_InitializeKeyword();																			// Ű ʱȭ
	inline			void	_InitializeKeywordPrep();																		// ó Ű ʱȭ
	inline			void	_InitializeKeywordIfElif();																		// #if #elif ڽ Ű ʱȭ
	inline			void	_InitializeKeywordPragma();																		// #pragma ڽ Ű ʱȭ
	inline			void	_GetMinMaxSize( const vector< string >& vecString, size_t& sizeMin, size_t& sizeMax ) const;	// ش ڿ ߿ ּ, ִ  
	inline			void	_InitializeTag();																				// ± ʱȭ
	__forceinline	bool	_IsSeparator( gunichar chLetter ) const;														// ش ڰ  
	__forceinline	bool	_IsNumber( gunichar chLetter ) const;															// ش ڰ   (0-9)
	__forceinline	bool	_IsAlphabet( gunichar chLetter ) const;															// ش ڰ ĺ  (A-Z, a-z)
	__forceinline	bool	_IsKeyword( const string& strKeyword ) const;													// ش ڿ Ϲ Ű 
	__forceinline	bool	_IsKeywordPrep( const string& strKeyword ) const;												// ش ڿ ó Ű 
	__forceinline	bool	_IsKeywordIfElif( const string& strKeyword ) const;												// ش ڿ #if #elif  ڽ Ű 
	__forceinline	bool	_IsKeywordPragma( const string& strKeyword ) const;												// ش ڿ #pragma  ڽ Ű 
	__forceinline	void	_ChangeTextColor();																				// ؽƮ    
};
#endif

