#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define BUF_SIZE 1024

int main()
{
	int nFd[2];
	pid_t pidChild;
	int nReadSize = 0;
	
	char pBuffer[ BUF_SIZE ];

	if( pipe(nFd) == -1 )
	{
		perror( "Failed to create the pipe\n" );
		return 1;
	}
	
	pidChild = fork();

	if( pidChild == -1 )
	{
		perror( "Failed to fork\n" );
		return 1;
	}
	
	if( pidChild  > 0 )
	{
		dup2( nFd[ 1 ] , STDOUT_FILENO );
		system( "./uno Test.c" );
	}
	else
	{
		dup2( nFd[ 0 ] , STDIN_FILENO );

		memset( pBuffer , 0 , BUF_SIZE );		
		while( 0 != ( nReadSize = read( STDIN_FILENO , pBuffer , BUF_SIZE ) ) )
		{
			printf( "nReadSize = %d , pBuffer = %s" , nReadSize , pBuffer );
			memset( pBuffer , 0 , BUF_SIZE );
		}
	}	

	close( nFd[ 0 ] );
	close( nFd[ 1 ] );

	return 0;
}
